<?php

namespace cold\DUELS;

use pocketmine\Server;
use pocketmine\Player;

use pocketmine\utils\Config;

use pocketmine\event\Listener;

use pocketmine\plugin\PluginBase;

use pocketmine\item\Item;
use pocketmine\command\Command;
use pocketmine\command\CommandSender;

use pocketmine\event\block\BlockBreakEvent;
use pocketmine\event\block\BlockPlaceEvent;

class Main extends PluginBase implements Listener {
  public function onEnable(){
    $this->getServer()->getPluginManager()->registerEvents($this, $this);
    $this->setup = new Config($this->getDataFolder() . "setup.yml", Config::YAML, array());
    $this->players = new Config($this->getDataFolder() . "players.yml", Config::YAML, array());
  }

  public function onCommand(CommandSender $sender, Command $cmd, string $label, array $args) : bool {
    $player = $sender;
    $player_name = $sender->getName();
    $player_orig = $sender->getPlayer();
    if(isset($args[0])){
      switch(strtolower($args[0])){
        case "setup":
          case "spawn":
            $level = $player->getLevel()->getFolderName();
            $load = $this->getServer()->loadLevel($level);
            if ($load) {
              $player->sendMessage("§2Success §r: §aWorld was been loaded");
              $player->teleport($this->getServer()->getLevelByName($level)->getSpawnLocation());
              $this->setup->set("Level", "$level");
              $this->setup->save();
              $player->sendMessage("§2Sucess §r: §aSaved the level");
              $this->setup->set("Status_1", "True");
              $this->setup->save();
            }else{
              $player->sendMessage("§4Error §r: §cWorld was not been loaded");
            }

            case 1:
              $level = $this->setup->get("Level");
              $load = $this->getServer()->loadLevel($level);

              $x = $player->getFloorX();
              $y = $player->getFloorY();
              $z = $player->getFloorZ();

              $this->setup->set("X_1", "$x");
              $this->setup->set("Y_1", "$y");
              $this->setup->set("Z_1", "$z");
              $this->setup->save();

              $player->sendMessage("§2Success §r: §aSpawn 1 was been saved");

              $this->setup->set("Status_2", "True");
              $this->setup->save();

            break;

            case 2:
              $level = $this->setup->get("Level");
              $load = $this->getServer()->loadLevel($level);

              $x = $player->getFloorX();
              $y = $player->getFloorY();
              $z = $player->getFloorZ();

              $this->setup->set("X_2", "$x");
              $this->setup->set("Y_2", "$y");
              $this->setup->set("Z_2", "$z");
              $this->setup->save();

              $player->sendMessage("§2Success §r: §aSpawn 2 was been saved");

              $this->setup->set("Status_3", "True");
              $this->setup->save();
            break;
          break;
        break;
        case "join":
          $status_1 = $this->setup->get("Status_1");
          $status_2 = $this->setup->get("Status_2");
          $status_3 = $this->setup->get("Status_3");

          if ($status_1 == "True" || $status_2 == "True" || $status_3 == "True") {
            $level = $this->setup->get("Level");

            $x_1 = $this->setup->get("X_1");
            $y_2 = $this->setup->get("Y_2");
            $z_3 = $this->setup->get("Z_3");

            $x_1 = $this->setup->get("X_1");
            $y_2 = $this->setup->get("Y_2");
            $z_3 = $this->setup->get("Z_3");

            if (empty($this->players->get("Count"))) {
              $count += 1;
              $this->players->set("Count", "$count");
              $this->players->save();
            }else{
              $count = $this->players->get("Count");
              $this->players->set("Count", "$count");
              $this->players->save();
            }

            if ($this->players->get("Count") == 1) {
              $this->players->set("Player_name_1", "$player_name");
              $this->players->set("Player_orig_1", "$player_orig");
              $this->players->save();
            }

            if ($this->players->get("Count") == 2) {
              $this->players->set("Player_name_2", "$player_name");
              $this->players->set("Player_orig_2", "$player_orig");
              $this->players->save();
            }

            $count = $this->players->get("count");

            if ($count == 2) {
              $player_name_1 = $this->players->get("Player_name_1");
              $player_name_2 = $this->players->get("Player_name_2");

              $player_orig_1 = $this->players->get("Player_orig_1");
              $player_orig_2 = $this->players->get("Player_orig_2");

              $player_orig_1->teleport($this->getServer()->getLevelByName($this->setup->get("Level"))->getSpawnLocation());
              $player_orig_1->teleport(new Vector3($this->setup->get("X_1"), $this->setup->get("Y_1"), $this->setup->get("Z_1")));

              $player_orig_2->teleport($this->getServer()->getLevelByName($this->setup->get("Level"))->getSpawnLocation());
              $player_orig_2->teleport(new Vector3($this->setup->get("X_2"), $this->setup->get("Y_2"), $this->setup->get("Z_2")));

              $player_orig_1->sendMessage("§aGame Was Started");
              $player_orig_2->sendMessage("§aGame Was Started");
            }
          }else{
            $player->sendMessage("§4Error §r: §cArena is not was enabled");
          }
          break;
      }
    }
  }
}
